' In order to run this example, put MediaInfo.dll and MediaInfoActiveX.dll
' into your system directory and Example.ogg into the root directory of drive
' C: (i.e. C:\). Use regsvr32.exe which is provided with Windows to register
' MediaInfoActiveX.dll.
'
' Use at own risk, under the same license as MediaInfo itself.
'
' Ingo Brckl, June 2005

Const InformOption_Nothing = 0
Const InformOption_Custom = 1
Const Stream_General = 0
Const Stream_Audio = 2
Const Info_Name = 0
Const Info_Text = 1

set obj = createObject("MediaInfo.ActiveX")

' information about MediaInfo

msgbox obj.MediaInfo_Option(0, "Info_Version", ""), ,"MediaInfo ActiveX Example"
msgbox obj.MediaInfo_Option(0, "Info_Parameters", ""), ,"Info_Parameters"
msgbox obj.MediaInfo_Option(0, "Info_Capacities", ""), ,"Info_Capacities"
msgbox obj.MediaInfo_Option(0, "Info_Codecs", ""), ,"Info_Codecs"

' an example of how to use the library

msgbox "Open", , "MediaInfo ActiveX Example"
handle = obj.MediaInfo_Open("C:\Example.ogg")

obj.MediaInfo_Option handle, "Complete", ""
msgbox obj.MediaInfo_Inform(handle, InformOption_Nothing), , "Inform with Complete=false"

obj.MediaInfo_Option handle, "Complete", "1"
msgbox obj.MediaInfo_Inform(handle, InformOption_Nothing), , "Inform with Complete=true"

obj.MediaInfo_Option handle, "Inform", "General;File size is %FileSize% bytes"
msgbox obj.MediaInfo_Inform(handle, InformOption_Custom), , "Custom Inform"

msgbox obj.MediaInfo_GetI(handle, Stream_General, 0, 13, Info_Text), , "GetI with Stream=General and Parameter=13"

msgbox obj.MediaInfo_Count_Get(handle, Stream_Audio, -1), , "Count_Get with StreamKind=Stream_Audio"

msgbox obj.MediaInfo_Get(handle, Stream_General, 0, "AudioCount", Info_Text, Info_Name), , "Get with Stream=General and Parameter=""AudioCount"""

msgbox obj.MediaInfo_Get(handle, Stream_Audio, 0, "StreamCount", Info_Text, Info_Name), , "Get with Stream=Audio and Parameter=""StreamCount"""

msgbox obj.MediaInfo_Get(handle, Stream_General, 0, "FileSize", Info_Text, Info_Name), , "Get with Stream=General and Parameter=""FileSize"""

msgbox "Close", , "MediaInfo ActiveX Example"
obj.MediaInfo_Close handle
